<template>
  <section id="forgot-password">
    <div class="container-fluid forgot-password-bg">
      <div class="row full-height-vh m-0 d-flex align-items-center justify-content-center">
        <div class="col-md-7 col-sm-12">
          <div class="card">
            <div class="card-content">
              <div class="card-body fg-image">
                <div class="row m-0">
                  <div class="col-lg-6 d-none d-lg-block text-center py-2">
                    <img src="/app-assets/img/gallery/forgot.png" alt="" class="img-fluid" width="300" height="230">
                  </div>
                  <div class="col-lg-6 col-md-12 bg-white px-4 pt-3">
                    <h4 class="mb-2 card-title">Reset Password</h4>
                    <p class="card-text mb-3">
                      Please enter your new password.
                    </p>
                    <div v-show="hasError" class="alert alert-danger" role="alert">
                      <strong>Error!</strong> Your password must be 6-20 characters long, contain letters and numbers, contain mixed case letters (upper and lower case) and must contain atleast one special character (@#$%&!*)(-+=^).
                    </div>  
                    <div class="form-group">
                      <div class="input-group">
                        <input :type="[collapsed ? 'password' : 'text']" v-model="form.password" class="form-control" placeholder="Enter New Password" required autocomplete="password">
                        <div class="input-group-addon">
                          <a href="#" @click=" collapsed = !collapsed"><i :class="[collapsed ? 'fa-eye-slash' : 'fa-eye', 'fa']" aria-hidden="true"/></a>
                        </div>
                      </div>
                    </div>
                    <div class="form-group">
                      <div class="input-group">
                        <input :type="[collapsedr ? 'password' : 'text']" v-model="rpassword" class="form-control" placeholder="Retype Password" required autocomplete="rpassword">
                        <div class="input-group-addon">
                          <a href="#" @click=" collapsedr = !collapsedr"><i :class="[collapsedr ? 'fa-eye-slash' : 'fa-eye', 'fa']" aria-hidden="true"/></a>
                        </div>
                      </div>
                    </div>
                    <div v-if="mismatch"><strong>Password do not match.</strong></div>

                    <div class="fg-actions d-flex justify-content-between">
                      <div class="login-btn">
                        <button class="btn btn-outline-primary">
                          <nuxt-link to="/authentication" class="text-decoration-none">
                            Back To Login
                          </nuxt-link>
                        </button>
                      </div>
                      <div class="recover-pass">
                        <button class="btn btn-primary" @click.prevent="onSubmit">
                          Save
                        </button>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>
<script>
import _ from 'lodash'
import to from 'await-to-js'
import Swal from 'sweetalert2'
export default {
  components: {
    Swal
  },
  layout: 'clean',
  data() {
    return {
      token: '',
      form: {
        password: ''
      },
      rpassword: '',
      mismatch: false,
      collapsed: true,
      collapsedr: true,
      hasError: false,
      strongRegex: new RegExp(
        '^(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])(?=.*[!@#$%^&*])(?=.{6,})'
      )
    }
  },
  mounted() {
    this.token = this.$route.query.token
  },
  methods: {
    async onSubmit(evt) {
      evt.preventDefault()

      if (this.rpassword != this.form.password) {
        this.mismatch = true
      } else {
        this.mismatch = false
        if (this.strongRegex.test(this.form.password)) {
          let [err, password] = await to(
            this.$axios.$put(
              `/api/userInfos/request/passwordReset/proceed?token=${
                this.token
              }`,
              this.form
            )
          )
          if (err || !password) {
            Swal.fire('Error!', 'Error on Updating Password', 'error')

            this.$router.push({ path: `/login/reset?token=${this.token}` })
          } else {
            Swal.fire('Success!', 'Password Successfully Reset', 'success')
            this.$router.push('/login')
          }
        } else {
          this.hasError = true
        }
      }
    }
  }
}
</script>
